
#include <jni.h>
#include "ostore_security_NativeRSAAlgorithm.h"
#include "gmp-interface.h"
#include <stdio.h>
#include <gmp.h>
#include <iostream>
#include <openssl/sha.h>
#include <openssl/evp.h>
#include <assert.h>
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <string.h>

#define PROFILE false

// The math in this function was cribbed from Cryptix, which cribbed it
// from PGP, which probably cribbed it from some theorist.  :)
JNIEXPORT jobject JNICALL 
Java_ostore_security_NativeRSAAlgorithm_rsa (
	JNIEnv *env, 
	jclass not_used, 
	jobject jX, 
	jobject jn, 
	jobject jexp, 
	jobject jp, 
	jobject jq, 
	jobject ju)
{
    jclass big_int_class = env->FindClass ("java/math/BigInteger");
    jmethodID big_int_init = 
	env->GetMethodID (big_int_class, "<init>", "([B)V");
    if (big_int_init == 0) 
	return 0;
    jmethodID big_int_to_byte_array = 
	env->GetMethodID (big_int_class, "toByteArray", "()[B");
    if (big_int_to_byte_array == 0) 
	return 0;

    mpz_t X, n, exp;
    mpz_init (X);
    mpz_init (n);
    mpz_init (exp);
    bigint2mpz (X, env, jX, big_int_to_byte_array);
    bigint2mpz (n, env, jn, big_int_to_byte_array);
    bigint2mpz (exp, env, jexp, big_int_to_byte_array);

    jobject result = 0;
    if (jp == 0) {
	mpz_powm (X, X, exp, n);
	result = mpz2bigint (env, X, big_int_class, big_int_init);
    }
    else {

	mpz_t p, q, u, primeExponentP, primeExponentQ;
	mpz_init (p);
	mpz_init (q);
	mpz_init (u);
	bigint2mpz (p, env, jp, big_int_to_byte_array);
	bigint2mpz (q, env, jq, big_int_to_byte_array);
	bigint2mpz (u, env, ju, big_int_to_byte_array);

	mpz_init (primeExponentP);
	mpz_init (primeExponentQ);
	mpz_sub_ui (primeExponentP, p, 1);
	mpz_sub_ui (primeExponentQ, q, 1);
	mpz_mod (primeExponentP, exp, primeExponentP);
	mpz_mod (primeExponentQ, exp, primeExponentQ);

	mpz_t tmp;
	mpz_init (tmp);
	mpz_invert (tmp, q, p);

	if (mpz_cmp (u, tmp) != 0) {
	    mpz_swap (p, q);
	    mpz_swap (primeExponentP, primeExponentQ);
	}

	mpz_t p2, q2;
	mpz_init (p2);
	mpz_init (q2);

	mpz_powm (p2, X, primeExponentP, p);
	mpz_powm (q2, X, primeExponentQ, q);

	if (mpz_cmp (p2, q2) == 0)
	    result = mpz2bigint (env, q2, big_int_class, big_int_init);
	else {
	    mpz_t k, l;
	    mpz_init (k);
	    mpz_init (l);
	    mpz_sub (k, p2, q2);
	    mpz_mod (k, k, p);
	    mpz_mul (l, k, u);
	    mpz_mod (l, l, p);
	    mpz_mul (l, q, l);
	    mpz_add (l, l, q2);

	    result = mpz2bigint (env, l, big_int_class, big_int_init);

	    mpz_clear (k);
	    mpz_clear (l);
	}

	mpz_clear (p2);
	mpz_clear (q2);
	mpz_clear (tmp);
	mpz_clear (u);
	mpz_clear (primeExponentP);
	mpz_clear (primeExponentQ);
	mpz_clear (p);
	mpz_clear (q);
    }

    mpz_clear (X);
    mpz_clear (n);
    mpz_clear (exp);

    return result;
}

