package ostore.tapestry.channel;
import ostore.tapestry.api.TapestryRouteMsg;
import ostore.tapestry.impl.RouteMsg;
import ostore.network.NetworkMessage;
import ostore.util.AssertionViolatedException;
import ostore.util.ByteUtils;
import ostore.util.CountBuffer;
import ostore.util.QuickSerializable;
import ostore.util.InputBuffer;
import ostore.util.NodeId;
import ostore.util.OutputBuffer;
import ostore.util.SecureHash;
import ostore.util.QSArray;
import ostore.util.QSByteArray;
import ostore.util.QSException;
import ostore.util.QuickSerializable;
import ostore.util.SecureHash;
import ostore.util.TypeTable;
import ostore.util.QuickSerializable;

public class ICMPPingMsg extends TapestryRouteMsg
    implements QuickSerializable{
    
    public NodeId src_id;
    public SecureHash msg_id;
    public SecureHash src;
    public int hop;
    
    public ICMPPingMsg(NodeId src_node, SecureHash msg_id, 
		       SecureHash src, SecureHash dest){
	super(dest);
	this.src_id = src_node;
	this.msg_id = msg_id;
	this.src = src;
	this.hop = 1;
    }
    
    public ICMPPingMsg(InputBuffer buffer) throws QSException{
	peer = (SecureHash)buffer.nextObject();
	src_id = (NodeId)buffer.nextObject();
	msg_id = (SecureHash)buffer.nextObject();
	src = (SecureHash)buffer.nextObject();
	hop = buffer.nextInt();
    }

    public void serialize (OutputBuffer buffer){
	buffer.add (peer);
	buffer.add (src_id);
	buffer.add (msg_id);
	buffer.add (src);
	buffer.add(hop);
    }

    public String toString(){
	    return "ICMP_PING_MSSG: src_id = " + src_id + 
		"; msg_id= " + msg_id + "; src= " + src + "; dest = " + peer;
    }
}







