package ostore.tapestry.impl;
import ostore.util.QSException;
import ostore.util.SecureHash;
import ostore.util.OutputBuffer;
import ostore.tapestry.api.TapestryRouteMsg;
import ostore.network.NetworkMessage;
import ostore.util.InputBuffer;
import ostore.util.NodeId;
import ostore.util.QuickSerializable;

public class FullTestMemberMsg 
extends NetworkMessage implements QuickSerializable 
{
    public SecureHash  guid;
    public int type;
    public static final int STATIC  = 0;
    public static final int DYNAMIC = 1;

    public FullTestMemberMsg (NodeId peer, SecureHash guid, int type) 
    {
      super (peer, false); //outbound
      this.guid = guid;
      this.type = type;
    }

    public FullTestMemberMsg (InputBuffer buffer) throws QSException 
    {
      super(buffer);
      boolean have_guid = buffer.nextBoolean();
      if ( have_guid )
	  guid = (SecureHash)buffer.nextObject();
      type = buffer.nextInt();
    }

    public void serialize (OutputBuffer buffer) 
    {
      super.serialize (buffer);
      if (guid == null)
	  buffer.add(false);
      else
      {
	  buffer.add(true);
	  buffer.add(guid);
      }
      buffer.add(type);
    }

    public String toString() 
    {
	if (type == STATIC)
	    return "FullTestMemberMsg from static client "  + 
		guid + " at (" + peer + ")";
	else
	    return "FullTestMemberMsg from dynamic client " + 
		guid + " at (" + peer + ")";
    }
}








