package ostore.tapestry.impl.Shuttle;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import ostore.tapestry.impl.*;
import java.util.*;
import java.io.*;
import java.security.*;

public class ChatFrame
    extends JFrame implements ActionListener, WindowListener {
    
    StringBuffer chatWindowStringBuffer;
    
    TestShuttle shuttleOwner;

    private JTextField textMsgField;
    //private JTextArea msgTextArea;
    private JEditorPane msgTextArea;

    private JButton sendButton;

    private String contact;
    
    private JButton closeButton;

    public ChatFrame(String con, TestShuttle owner) {
	super(owner.GetLogin() + ": Chat with "+con);
	contact = con;

	chatWindowStringBuffer = new StringBuffer();

	shuttleOwner = owner;
	Container contentPane = getContentPane();
	contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
	
	/*GridBagLayout gridBag = new GridBagLayout();	
	contentPane.setLayout(gridBag);	
	GridBagConstraints c = new GridBagConstraints();*/
	
		
	textMsgField = new JTextField(20);
	//textMsgField.setMinimumSize(20, 1);
	//textMsgField.setPreferredSize(20, 1);

	//msgTextArea = new JTextArea(20, 20);
	msgTextArea = new JEditorPane("text/html", "<html><body>");
	
	//msgTextArea = new JEditorPane();
	msgTextArea.setEditable(false);
		
	sendButton = new JButton("send");
	sendButton.addActionListener(this);
	
	closeButton = new JButton("close");
	closeButton.addActionListener(this);

	JScrollPane scrollPane = new JScrollPane(msgTextArea,
						 JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
						 JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

	scrollPane.setMinimumSize(new Dimension(200, 400));
	scrollPane.setPreferredSize(new Dimension(200, 400));
	scrollPane.setAlignmentX(LEFT_ALIGNMENT);
	

	
	textMsgField.addActionListener(this);

	
	JPanel textPane = new JPanel();      
	textPane.setLayout(new BoxLayout(textPane, BoxLayout.Y_AXIS));        
        
	textPane.add(scrollPane);
	textPane.add(textMsgField);
	
	
	contentPane.add(textPane);
	contentPane.add(sendButton);      
	contentPane.add(closeButton);

	pack();

	/*addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    this.dispose();
		}
		});*/
	addWindowListener(this);
    }
    public void windowClosing(WindowEvent e) {
	shuttleOwner.HandleChatFrameClosing(contact, this);
	this.dispose();
    }
    
    public void windowClosed(WindowEvent e) {	
    }
    
    public void windowOpened(WindowEvent e) {	
    }
    
    public void windowIconified(WindowEvent e) {	
    }
    
    public void windowDeiconified(WindowEvent e) {	
    }
    
    public void windowActivated(WindowEvent e) {	
    }
    
    public void windowDeactivated(WindowEvent e) {	
    }
    
    public synchronized void addSelfChatText(String login, String msg)
    {	
	chatWindowStringBuffer.append("<font color=\"#CC9900\"><b>"+login+"</b></font>: "+msg+"<br>\n");
	msgTextArea.setText(chatWindowStringBuffer.toString());
    }

    public synchronized void addChatText(String user, String msg)
    {	
	chatWindowStringBuffer.append("<font color=\"#0000FF\"><b>"+user+"</b> </font>: "+msg+"<br>\n");
	msgTextArea.setText(chatWindowStringBuffer.toString());
	//msgTextArea.setText(asdf + "<br>" + "<b><"+user+"></b> : "+msg+"\n");	
    }


    public void actionPerformed(ActionEvent e)
    {	       
	if(e.getSource() == closeButton) {
	    shuttleOwner.HandleChatFrameClosing(contact, this);
	    this.dispose();
	}else{
	    shuttleOwner.HandleChatSendMsg(this, contact, textMsgField.getText());
	    textMsgField.selectAll();
	}
	
    }

    public void make_visible() {
	setVisible(true);
    }

    public void make_hidden() {
	setVisible(false);
    }
}
