package ostore.tapestry.impl.Shuttle;
import ostore.tapestry.impl.*;
import ostore.util.QSException;
import ostore.util.SecureHash;
import ostore.security.*;
import ostore.util.SHA1Hash;
import ostore.util.OutputBuffer;
import ostore.util.ByteUtils;
import ostore.util.TypeTable;
import ostore.tapestry.api.TapestryQuery;
import ostore.tapestry.api.TapestryQueryState;
import ostore.tapestry.api.TapestryLocateMsg;
import ostore.tapestry.api.TapestryPrefixRouteMsg;
import ostore.util.QuickSerializable;
import ostore.util.InputBuffer;

public class ShuttleRequestStorageMsg extends TapestryPrefixRouteMsg {
    String requestType; /*either "store" or "retrieve" */
    SecureHash key;
    String value;
    
    public ShuttleRequestStorageMsg(SecureHash dest_guid) {
	super(dest_guid, false);
	value = new String("crap");
	key = new SHA1Hash("0");
	requestType = new String("crap");
    }


    public ShuttleRequestStorageMsg (InputBuffer buffer)
	throws QSException 
    {
	//super(buffer);  Ben's example DynamicSurrogateMsg had this commented out also
	requestType = buffer.nextString();
	key = (SecureHash) buffer.nextObject();
	value =  buffer.nextString();
    }
    /*old! 
      public ShuttleRequestStorageMsg(byte[] data, int[] offset)
      throws QSException {
      long type = ByteUtils.bytesToLong(data, offset);
      requestType = ByteUtils.bytesToString(data, offset);
      
      type = ByteUtils.bytesToLong(data, offset);
      key = (SecureHash) TypeTable.new_object(type, data, offset);
      
      type = ByteUtils.bytesToLong(data, offset);
      value = ByteUtils.bytesToString(data, offset); 
      }*/

    


    public void InitStoreRequest(SecureHash key, String value) {
	this.requestType = "store";
	this.key = key;
	this.value = value;
    }

    public void InitRetrieveRequest(SecureHash key) {
	this.requestType = "retrieve";
	this.key = key;
	this.value = "";
    }
    
    public void serialize (OutputBuffer buffer) {
	//super.serialize(buffer);

	buffer.add(requestType);
	buffer.add(key);
	buffer.add(value);
    } 
    public String toString() {
	return "ShuttleRequestStorageMsg for requestType "+requestType+", key "+key+" value "
	    +value+" from/to="+ peer+")";
    }

    

}
