package ostore.tapestry.impl.test;
import ostore.tapestry.patchwork.ProbPDF;
import ostore.tapestry.patchwork.CDF;
import ostore.util.RandomExponential;

/** Specifies a CDF and a PDF for churning */
public class ChurnPDF implements ProbPDF, CDF {

    // fail 20% of the nodes (DEFAULT)
    private double failrate = .2;

    // does nothing
    private int failperiod = 5;
    // how often is this checked?
    private int failincrement = 1000;
    private long seed;
    private long factor = 10000000;

    RandomExponential rand = new RandomExponential(1.0/failrate);
    private int num;

    public double getPDFEntry( int n ) {
	double first = rand.nextDouble();
	double second = rand.nextExponential();
	num++;
	//System.out.println( "comparing " + first + " and " + second );
	if( first < second ) {
	    //System.out.println( "1 out of " + num + " = " + (1/num) );
	    num = 0;
	    return 1;
	} else {
	    return 0;
	}
    }

    public int getPDFSize() {
	return Integer.MAX_VALUE;
    }

    public int getPDFIncrement() {
	return failincrement;
    }

    public void setSeed( long seed ) {
	rand.setSeed( seed );
	this.seed = seed;
    }

    public void setRate( double rate ) {
	failrate = rate;
	rand = new RandomExponential(1.0/failrate, seed);
    }

    public void setInterval( int interval ) {
	failperiod = interval;
    }

    public double getCDFEntry( int n ) {
	return 0;
    }

    public int getCDFSize() {
	return getPDFSize();
    }

    public int getCDFIncrement() {
	return getPDFIncrement();
    }

}
