/**
 * InterweaveSearchResult.java
 *
 * @author   Benjamin K. Poon
 * @version  $Id: InterweaveSearchResult.java,v 1.1 2002/11/20 09:45:09 bpoon1 Exp $
 *
 * Copyright (c) 2001 Regents of the University of California.
 * All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the University nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 *  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 **/

package ostore.tapestry.interweave;
import ostore.util.SecureHash;

public class InterweaveSearchResult {
    public SecureHash peer;
    public String filename;
    public String login;
    public long lastModified;
    public long size;
    public String type;

    public InterweaveSearchResult(SecureHash peer, 
				  String filename, String login, long lastModified, long size, String type) {
	this.peer = peer;
	this.filename = filename;
	this.login = login;
	this.lastModified = lastModified;
	this.size = size;
	this.type = type;
    }

    public String toString() {
	return peer + "\t" + filename + "\t" + login + "\t" + lastModified + "\t" + size + "\t" + type;
    }

    public boolean equals(Object obj) {
	if (obj instanceof InterweaveSearchResult) {
	    InterweaveSearchResult isr = (InterweaveSearchResult)obj;
	    return ((isr.filename).equals(filename) &&
		    (isr.login).equals(login) &&
		    isr.lastModified == lastModified &&
		    isr.size == size &&
		    (isr.type).equals(type));
	}
	return false;
    }
}
