package ostore.tapestry.patchwork;

/** Specifies a CDF that always returns 1.
 * This means nodes will always fail or be revived right away
 *
 * NOTE: getPDFEntry returns 1.0 and getCDFEntry returns 0.0.
 * This is to accurately calculate, what is the probability
 * that a node dies (or comes to life) during the specified 
 * interval. That is p[pdf(n)/1.0-cdf(n)].
 */
public class AllOnesPDF implements PDF, CDF {

    public double getPDFEntry( int n ) {

	return 1.0;
    }

    public int getPDFSize() {
	return 1;
    }

    public int getPDFIncrement() {
	return 1;
    }

    public double getCDFEntry( int n ) {

	return 0.0;
    }

    public int getCDFSize() {
	return 1;
    }

    public int getCDFIncrement() {
	return 1;
    }

}

