/**
 * RMFoundMsg.java
 *
 * @author     Jeremy Stribling
 * @version    $Id: RMFoundMsg.java,v 1.1 2002/12/20 23:54:24 strib Exp $
 */

package ostore.tapestry.patchwork;
import ostore.util.NodeId;
import ostore.network.NetworkMessage;
import ostore.util.QSException;
import ostore.util.SecureHash;
import ostore.util.OutputBuffer;
import ostore.tapestry.api.TapestryRouteMsg;
import ostore.util.InputBuffer;
import ostore.util.QuickSerializable;

/**
 * The msg to say we found the RepairMonitor
 */
public class RMFoundMsg 
  extends NetworkMessage implements QuickSerializable {

    public RMFoundMsg( NodeId peer ) {
	super( peer, false /*outbound*/ );
    } 
    
    public RMFoundMsg (InputBuffer buffer) throws QSException {
	super(buffer);
    }
    
    public void serialize (OutputBuffer buffer) {
	super.serialize (buffer);
    }

    public String toString() {
	return "(RMFoundMsg from/to="+ peer+ ")";
    }
}


