package ostore.tapestry.patchwork;

/** Specifies a CDF in seconds */
public class SecondPDF extends DiskPDF {

    /**
     * How much to divide the month PDF by
     */
    public static final int factor = (int) (60 /*sec/min*/ * 60 /*min/hour*/
					    * 24 /*hour/day*/ * 7 /*day/wk*/ 
					    * 4.25 /*wk/month*/);

    public static final int pdf_size = (int) ((dPDFarray.length-1)*factor);
    public static final int cdf_size = (int) ((dCDFarray.length-1)*factor);

    public double getPDFEntry( int n ) {

	// first decide which month bucket to split up
	int month = (int) Math.floor(n/factor);

	return dPDFarray[month]/factor;
    }

    public int getPDFSize() {
	return pdf_size;
    }

    public int getPDFIncrement() {
	return 1000;
    }

    public double getCDFEntry( int n ) {

	// first decide which month bucket to split up
	int month = (int) Math.floor(n/factor);
	// then fiure out the difference in seconds
	long diff = n - month*factor;
	return dCDFarray[month] + diff*dPDFarray[month]/factor;
    }

    public int getCDFSize() {
	return cdf_size;
    }

    public int getCDFIncrement() {
	return 1000;
    }

}

