#!/usr/bin/perl 
# Written by Anthony D. Joseph (adj@eecs.berkeley.edu)
# August 25, 2002

use Tools;

my %value_map;
my @nodes = (2, 5, 10, 20, 50, 100, 150, 200);
my $Static  = 5;
my $base_port;

my $result_log = "/home/hling/planetlab/dyn_lookup.log";
#open STDOUT, ">$result_log" or &die( "can't redirect STDOUT");
#open STDERR, ">&STDOUT" or &die( "can't redirect STDERR");

my $result_file = "/home/hling/planetlab/dyn_lookup.dat";
open (OUT, ">$result_file");

$i = 1;
for $i (1 .. 1)
{
    $base_port = 7215;
#    for $j (0 .. 4)
    {
	system "rm -rf /tmp/*";

	my $Dynamic = $nodes[$i];
	my $all_nodes = $Static + $Dynamic;
	print "Generate exp files...\n";
	system "gen_exp_local.pl -s $Static -d $Dynamic head_local.exp";
	my $template = "fulltest-driver.cfg";
	$driver_cfg   = "/tmp/fulltest-driver-$nodes[$i].cfg";
	$driver_log   = "/tmp/fulltest-driver-$nodes[$i].log";
	$value_map{"NodeNumber"} = "$all_nodes";
	# Now write the new, interpolated file.
	print "Generate cfg files...\n";
	&interpolate( $template, $driver_cfg, \%value_map );

	# Start the driver node and wait to see that it's running.
	print "Start drive node...\n";
	&fork_sandstorm( $driver_cfg, $driver_log);
	&wait_for_network_ready( $driver_log );
	
	print "Run Experiment...\n";
	$base_port = $base_port + 10;
	my $exp_file = "/tmp/tapestry_planetlab_s" . $Static . "_d" . $Dynamic . ".exp";
	system "run-experiment $exp_file $base_port";

	print "Waiting for Succeed...\n";
	&wait_for( $driver_log, "^FullTestDriver.handle_respmsg: Succeed in nodes insertion" );
	print "Test finished! Killall -9 java...\n";
	system "killall -9 java";

	print "Parsing results...\n";
	my $result_string = `grep "parallel insertion within time" /tmp/*.log`;
#    $result_string =~ s/Complete:\s*(\S*)/$1/;
	print OUT "$nodes[$i] nodes:\n$result_string";
    }

    print OUT "\n";
}

close OUT;





