#!/usr/bin/perl 
# Written by Anthony D. Joseph (adj@eecs.berkeley.edu)
# August 25, 2002

use Tools;

my %value_map;
my @nodes = (2, 5, 10, 20, 40, 70, 100, 150, 200, 250, 300, 400, 500);
my $base_port;

my $result_file = "/home/hling/planetlab/single_integration_raw.dat";
open (OUT, ">$result_file");

$i = 3;
#for $i (3 .. 12)
{
    $base_port = 7225;
    for $j (0 .. 4)
    {
	system "rm -rf /tmp/*";

	system "gen_exp.pl -s $nodes[$i] -d 1 head.exp";
	my $Static  = $nodes[$i];
	my $Dynamic = 1;
	my $all_nodes = $Static + $Dynamic;
	my $template = "fulltest-driver.cfg";
	$driver_cfg   = "/tmp/fulltest-driver-$nodes[$i].cfg";
	$driver_log   = "/tmp/fulltest-driver-$nodes[$i].log";
	$value_map{"NodeNumber"} = "$all_nodes";
	# Now write the new, interpolated file.
	&interpolate( $template, $driver_cfg, \%value_map );

	# Start the driver node and wait to see that it's running.
	&fork_sandstorm( $driver_cfg, $driver_log);
	&wait_for_network_ready( $driver_log );
	
	$base_port = $base_port + 10;
	my $exp_file = "/tmp/tapestry_planetlab_s" . $Static . "_d" . $Dynamic . ".exp";
	system "run-experiment $exp_file $base_port";

	&wait_for( $driver_log, "^FullTestDriver.handle_respmsg: Succeed in nodes insertion" );
	print "Test finished! Killall java...\n";
	system "killall -9 java";

	my $result_string = `grep "time in ms" /tmp/*.log`;
#    $result_string =~ s/Complete:\s*(\S*)/$1/;
	print OUT "$nodes[$i] nodes:  $result_string";

	my $seconds = 30;
	print "Sleep for $seconds seconds...\n";
	system "sleep $seconds";
    }

    print OUT "\n";
}

close OUT;



