#!/usr/bin/perl 
# Written by Anthony D. Joseph (adj@eecs.berkeley.edu)
# August 25, 2002

use Tools;

my %value_map;
my @nodes = (5, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 150, 200);
my $Static  = 200;
my $base_port;

my $day = `date +%d`;
my $month = `date +%m`;
my $time = `date +%T`;
chomp ($day);
chomp ($month);
chomp ($time);
my $file_time = $month . $day . "_" . $time;
my $result_log = "./" . $file_time . "_single_integration_raw.log";
my $result_file = "./" . $file_time. "_parallel_integration_raw.dat";

#open STDOUT, ">$result_log" or &die( "can't redirect STDOUT");
#open STDERR, ">&STDOUT" or &die( "can't redirect STDERR");
open (OUT, ">$result_file");

#system "killall -9 run_parallel_insertion.pl";
$i = 1;
for $i (2 .. 12)
{
    $base_port = 6600;
#    for $j (0 .. 4)
    {
#	system "rm -rf /tmp/*.cfg";
#	system "rm -rf /tmp/*.log";
#	system "rm -rf /tmp/*.exp";
#	system "rm -rf /tmp/*.tmp";

	my $Dynamic = $nodes[$i];
#	my $Dynamic = 1;
	my $all_nodes = $Static + $Dynamic;
	print "Generate exp files...\n";
	system "./gen_exp.pl -s $Static -d $Dynamic head.exp";
#	my $template = "fulltest-driver.cfg";
	#Use YANetwork
	my $template = "fulltest-driver-yan.cfg";
	$driver_cfg   = "/tmp/fulltest-driver-$nodes[$i].cfg";
	$driver_log   = "/tmp/fulltest-driver-$nodes[$i].log";
	$value_map{"NodeNumber"} = "$all_nodes";
	# Now write the new, interpolated file.
	print "Generate cfg files...\n";
	&interpolate( $template, $driver_cfg, \%value_map );

	# Start the driver node and wait to see that it's running.
	print "Start drive node...\n";
	&fork_sandstorm( $driver_cfg, $driver_log);
	&wait_for_network_ready( $driver_log );
	
	print "Run Experiment...\n";
	my $exp_file = "/tmp/tapestry_planetlab_s" . $Static . "_d" . $Dynamic . ".exp";
	system "./run-experiment -port $base_port $exp_file";

	print "Waiting for Succeed...\n";
	&wait_for( $driver_log, "^FullTestDriver.handle_respmsg: Succeed in nodes insertion" );

	print "Testing finished! Parsing results...\n";
	print OUT "Results for Insertion with $nodes[$i] nodes:\n";
	my $result_string = `grep "Inserted nodes" /tmp/*.log`;
	print OUT "$result_string";
	my $result_string = `grep "Max insertion time" /tmp/*.log`;
#    $result_string =~ s/Complete:\s*(\S*)/$1/;
	print OUT "$result_string";
	my $result_string = `grep "parallel insertion within time" /tmp/*.log`;
	print OUT "$result_string";

#	print "Killall -9 java...\n";
#	system "killall -9 java";
#	system "killall -9 ssh";
#	system "killall -9 ssp";
#	system "killall_java_remote";
	my $seconds = 60;
	print "Sleep for $seconds seconds...\n";
	system "sleep $seconds";
    }

    print OUT "\n";
}

close OUT;
